%define svn 1
%define snapshot 20140428

Name: cp2k
Version: 2.4
Release: 4.%{snapshot}svn13818%{?dist}
Group: Applications/Engineering
Summary: Ab Initio Molecular Dynamics
License: GPLv2+
URL: http://cp2k.org/
%if %{svn}
# run cp2k-snapshot.sh to produce this
Source0: cp2k-%{version}-%{snapshot}.tar.xz
%else
Source0: http://downloads.sourceforge.net/project/cp2k/cp2k-%{version}.tar.bz2
%endif
Source4: cp2k-snapshot.sh
# patch to:
# use rpm optflags
# link with atlas instead of vanilla blas/lapack
# build with libint and libxc
# use external makedepf90
# skip compilation during regtests
Patch0: %{name}-rpm.patch
Patch1: %{name}-ppc64.patch
BuildRequires: atlas-devel
# for regtests
BuildRequires: bc
BuildRequires: fftw-devel
BuildRequires: gcc-gfortran
BuildRequires: libint-devel >= 1.1.4
BuildRequires: libxc-devel
BuildRequires: makedepf90
BuildRequires: /bin/hostname

Obsoletes: %{name}-smp < 2.4-1
Provides: %{name}-smp = %{version}-%{release}
BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)

Requires: %{name}-common = %{version}-%{release}
# Libint may have API breakage
Requires: libint(api)%{?_isa} = %{_libint_apiversion}

%global cp2k_desc_base \
CP2K is a freely available (GPL) program, written in Fortran 95, to\
perform atomistic and molecular simulations of solid state, liquid,\
molecular and biological systems. It provides a general framework for\
different methods such as e.g. density functional theory (DFT) using a\
mixed Gaussian and plane waves approach (GPW), and classical pair and\
many-body potentials.\
\
CP2K does not implement Car-Parinello Molecular Dynamics (CPMD).

%description
%{cp2k_desc_base}

This package contains the non-MPI single process and multi-threaded versions.

%package openmpi
Group: Applications/Engineering
Summary: Molecular simulations software - openmpi version
BuildRequires:  openmpi-devel
BuildRequires:  blacs-openmpi-devel
BuildRequires:  scalapack-openmpi-devel
Requires: %{name}-common = %{version}-%{release}
Requires: blacs-openmpi
Requires: scalapack-openmpi
# Libint may have API breakage
Requires: libint(api)%{?_isa} = %{_libint_apiversion}

%description openmpi
%{cp2k_desc_base}

This package contains the parallel single- and multi-threaded versions
using OpenMPI.

# mpich not available on the following due to bug #613122
%ifnarch ppc ppc64 s390 s390x
%package mpich
Group: Applications/Engineering
Summary: Molecular simulations software - mpich version
BuildRequires:  mpich-devel
BuildRequires:  blacs-mpich-devel
BuildRequires:  scalapack-mpich-devel
Requires: %{name}-common = %{version}-%{release}
Requires: blacs-mpich
Requires: scalapack-mpich
# Libint may have API breakage
Requires: libint(api)%{?_isa} = %{_libint_apiversion}
Obsoletes: %{name}-mpich2 < 2.4-3
Provides: %{name}-mpich2 = %{version}-%{release}

%description mpich
%{cp2k_desc_base}

This package contains the parallel single- and multi-threaded versions
using mpich.
%endif

%package common
Group: Applications/Engineering
Summary: Molecular simulations software - common files

%description common
%{cp2k_desc_base}

This package contains the documentation and the manual.

%prep
%setup -q
%patch1 -p1 -b .ppc64
TARGET=$(tools/get_arch_code)
%ifnarch x86_64
ln -s Linux-x86-64-gfortran.sopt arch/${TARGET}.sopt
ln -s Linux-x86-64-gfortran.ssmp arch/${TARGET}.ssmp
%endif
ln -s Linux-x86-64-gfortran.popt arch/${TARGET}-openmpi.popt
ln -s Linux-x86-64-gfortran.popt arch/${TARGET}-mpich.popt
ln -s Linux-x86-64-gfortran.psmp arch/${TARGET}-openmpi.psmp
ln -s Linux-x86-64-gfortran.psmp arch/${TARGET}-mpich.psmp
%patch0 -p1 -b .r
rm -r tools/makedepf90
chmod -x src/harris_{functional,{env,energy}_types}.F
# fix crashes in fftw on i686
%ifarch i686
sed -i 's/-D__FFTW3/-D__FFTW3 -D__FFTW3_UNALIGNED/g' arch/Linux-x86-64-gfortran*
%endif

# Get libint and libderiv limits
maxam=`grep LIBINT_MAX_AM %{_includedir}/libint/libint.h | awk '{print $3}'`
maxderiv=`grep "LIBDERIV_MAX_AM1 " %{_includedir}/libderiv/libderiv.h | awk '{print $3}'`
# Plug them in the configuration
for f in arch/Linux-x86-64-gfortran.{popt,psmp,sopt,ssmp}; do
 sed -i "s|@LIBINT_MAX_AM@|$maxam|g;s|@LIBDERIV_MAX_AM@|$maxderiv|g" $f
done

%build
TARGET=$(tools/get_arch_code)
pushd makefiles
    %{_openmpi_load}
        make OPTFLAGS="%{optflags} -L%{_libdir}/atlas" %{?_smp_mflags} ARCH="${TARGET}-openmpi" VERSION=popt
        make OPTFLAGS="%{optflags} -L%{_libdir}/atlas" %{?_smp_mflags} ARCH="${TARGET}-openmpi" VERSION=psmp
    %{_openmpi_unload}
%ifnarch ppc ppc64 s390 s390x
    %{_mpich_load}
        make OPTFLAGS="%{optflags} -L%{_libdir}/atlas" %{?_smp_mflags} ARCH="${TARGET}-mpich" VERSION=popt
        make OPTFLAGS="%{optflags} -L%{_libdir}/atlas" %{?_smp_mflags} ARCH="${TARGET}-mpich" VERSION=psmp
    %{_mpich_unload}
%endif

    make OPTFLAGS="%{optflags} -L%{_libdir}/atlas" %{?_smp_mflags} sopt ssmp
popd

%install
TARGET=$(tools/get_arch_code)
install -d %{buildroot}%{_bindir}
%{_openmpi_load}
    mkdir -p %{buildroot}%{_libdir}/openmpi%{?_opt_cc_suffix}/bin/
    install -pm755 exe/${TARGET}-openmpi/cp2k.popt %{buildroot}%{_libdir}/openmpi%{?_opt_cc_suffix}/bin/cp2k.popt_openmpi
    install -pm755 exe/${TARGET}-openmpi/cp2k.psmp %{buildroot}%{_libdir}/openmpi%{?_opt_cc_suffix}/bin/cp2k.psmp_openmpi
%{_openmpi_unload}
%ifnarch ppc ppc64 s390 s390x
%{_mpich_load}
    mkdir -p %{buildroot}%{_libdir}/mpich%{?_opt_cc_suffix}/bin/
    install -pm755 exe/${TARGET}-mpich/cp2k.popt %{buildroot}%{_libdir}/mpich%{?_opt_cc_suffix}/bin/cp2k.popt_mpich
    install -pm755 exe/${TARGET}-mpich/cp2k.psmp %{buildroot}%{_libdir}/mpich%{?_opt_cc_suffix}/bin/cp2k.psmp_mpich
%{_mpich_unload}
%endif
install -pm755 exe/${TARGET}/cp2k.sopt %{buildroot}%{_bindir}
install -pm755 exe/${TARGET}/cp2k.ssmp %{buildroot}%{_bindir}

%clean
rm -rf %{buildroot}

%if 1
%check
cat > tests/fedora.config << __EOF__
export LC_ALL=C
dir_base=%{_builddir}
cp2k_version=sopt
dir_triplet=`tools/get_arch_code`
cp2k_dir=cp2k-%{version}
maxtasks=`getconf _NPROCESSORS_ONLN`
emptycheck="NO"
leakcheck="NO"
__EOF__
pushd tests
../tools/do_regtest -config fedora.config
popd
%endif

%files common
%defattr(-,root,root,-)
%doc COPYRIGHT README doc/tutorialCp2k.html

%files
%defattr(-,root,root,-)
%{_bindir}/cp2k.sopt
%{_bindir}/cp2k.ssmp

%files openmpi
%defattr(-,root,root,-)
%{_libdir}/openmpi%{?_opt_cc_suffix}/bin/cp2k.popt_openmpi
%{_libdir}/openmpi%{?_opt_cc_suffix}/bin/cp2k.psmp_openmpi

# mpich not available on the following due to bug #613122
%ifnarch ppc ppc64 s390 s390x
%files mpich
%defattr(-,root,root,-)
%{_libdir}/mpich%{?_opt_cc_suffix}/bin/cp2k.popt_mpich
%{_libdir}/mpich%{?_opt_cc_suffix}/bin/cp2k.psmp_mpich
%endif

%changelog
* Mon May 22 2017 Susi Lehtola <jussilehtola@fedoraproject.org> - 2.4-4.20140428svn13818
- Modernize libint dependencies.

* Sun Nov 30 2014 Dominik Mierzejewski <rpm@greysector.net> - 2.4-3.20140428svn13818
- update to latest 2.4 branch snapshot
- fix build against current blacs/scalapack
- mpich2 got renamed to mpich
- fix description (cp2k doesn't implement Car-Parinello Molecular Dynamics)

* Tue Dec 24 2013 Susi Lehtola <jussilehtola@fedoraproject.org> - 2.4-2.20130620svn12994
- Rebuild against libint.

* Fri Nov 15 2013 Dominik Mierzejewski <rpm@greysector.net> - 2.4-1.20130620svn12994
- update to latest 2.4 branch snapshot
- drop mpich2 subpackage on ppc(64) and s390(x)
- use xz to compress SVN snapshot tarball
- build psmp variants (MPI+OpenMP)
- move ssmp build to main package and drop smp subpackage
- save the output of tools/get_arch_code and re-use it
- use (and patch) upstream-provided configs for x86_64 ssmp and popt builds
- no need to force FC=gfortran anymore
- link with libf77blas for MPI builds to avoid undefined reference to symbol 'dgemm_'
- fix crashes in fftw on i686 (patch by Michael Banck)
- add requires for respective blacs and scalapack versions
- add -ffree-line-length-none to Fortran flags
- add a patch to echo the name of reach test (from Debian package)
- build with libxc
- pass special CFLAGS to support libint's higher values of angular momentum
- added snapshot creator script
- define common description macro (Thomas Spura)
- also build with openmpi/mpich2 (Thomas Spura)
- new url (Thomas Spura)

* Tue Dec 07 2010 Dominik Mierzejewski <rpm@greysector.net> 2.1-2.20101006
- make Summary more descriptive
- use atlas instead of blas/lapack

* Fri Dec 03 2010 Dominik Mierzejewski <rpm@greysector.net> 2.1-1.20101006
- initial package
